<template lang="pug">
.uploader
  span.input__label.input__label_active {{ label }}
    span.input__label-required &nbsp;*

  el-upload.poster-block(
    :action='uploadFormHost'
    :ref="refUpload"
    :data = 'uploadForm'
    :auto-upload="autoUpload"
    :on-preview='handlePreview'
    :limit='limitFile'
    :on-remove='handleRemove'
    :on-success='successUpload'
    :on-change='changePhoto'
    :file-list='poster'
    list-type="picture"
    :on-exceed="handleExceed"
    drag)
    i.el-icon-upload
    .el-upload__text
      | Перетащите фото или&nbsp;
      em кликните для загрузки

  el-dialog(
  :visible.sync='dialogVisible')
    img(width='100%', :src='dialogImageUrl', alt='')
</template>

<script>
export default {
  name: 'Uploader',
  props: {
    label: {
      type: String,
      required: true
    },
    uploadFormHost: {
      type: String,
      required: true
    },
    uploadForm: {
      type: Object,
      required: false,
      default: () => {}
    },
    autoUpload: {
      type: Boolean,
      required: false,
      default: false
    },
    limitFile: {
      type: Number,
      required: false,
      default: 1
    },
    photo: {
      type: String,
      required: false,
      default: ''
    },
    refUpload: {
      type: String,
      required: false,
      default: 'upload'
    },
    readyToShip: {
      type: Boolean,
      required: false,
      default: false
    }
  },
  data() {
    return {
      dialogImageUrl: '',
      dialogVisible: false,
      poster: []
    };
  },
  watch: {
    readyToShip(value) {
      if (value) {
        this.submitPhoto();
      }
    }
  },
  mounted() {
    if (this.photo) {
      this.poster.push({
        url: this.photo,
        name: this.photo.split('/')[this.photo.split('/').length - 1]
      });
    }
  },
  methods: {
    handleExceed(files, fileList) {
      this.$message.warning(
        `Вы можете загрузить только ${
          this.limitFile
        } фото. Пожалуйста, удалите существующее, чтобы загрузить новое.`
      );
    },
    handlePreview(file) {
      this.dialogImageUrl = file.url;
      this.dialogVisible = true;
    },
    handleRemove(file, fileList) {
      this.poster = [];
      this.$emit('remove-photo', this.photo);
    },
    changePhoto(file) {
      this.$emit('change-photo', file.url);
    },
    submitPhoto() {
      this.$refs.upload.submit();
    },
    successUpload(response) {
      this.$emit('success-upload', response);
    }
  }
};
</script>

<style lang="scss">
.uploader {
  position: relative;
}
</style>
